Player = class("Player")

PlayerColors = {
	Color:new(255,255,255,128),
	Color:new(255,255,188,255),
	Color:new(255,255,100,100),
	Color:new(255,128,128,255),
}

function Player:new(colorId)
	local o = instance(self)
	o.input = {}
	o.id = colorId
	o.pressed = 0
	o.killFeedback = 0
	o.deadFade = 0
	o.wins = 0
	o.kills = 0
	if colorId then
		o.color = PlayerColors[colorId]
	else
		o.color = Color:new(255,255,255,255)
	end
	return o
end

function Player:randomizeColor()
	self.color = Color:new(255, math.random(50,255), math.random(50,255), math.random(50,255))
end

function Player:update(time)
	self.pressed = math.max(0,self.pressed - time*5)
	self.killFeedback = math.max(0,self.killFeedback - time*4)
	if self.dead then
		self.deadFade = math.min(1,self.deadFade + time)
	else
		self.deadFade = math.max(0,self.deadFade - time)
	end
	if self.showRespawnText then
		self.showRespawnText = self.showRespawnText - time
	end

	if self.respawnBonusTimer then
		self.respawnBonusTimer = math.approach(self.respawnBonusTimer, 0, time*5)
	end
end

function Player:action()
	self.pressed = 1
end	

function Player:setInput(device, key, deviceId)
	self.input.device = device
	self.input.key = key
	self.input.deviceId = deviceId
end	

function Player:renderInputKeyAt(x,y, scale)
	local fade = self.pressed*self.pressed
	local scale = scale + 1*fade
	video.renderTextSprites(Hints.getHint(self.input.device, self.input.key, self.input.deviceId), x,y  + fonts.alignY("medium", scale), 1, "medium", 255,math.approach(self.color.r, 255, fade*255),math.approach(self.color.g, 255, fade*255),math.approach(self.color.b, 255, fade*255), nil, scale)
end
