SPRITES = {}

sprites = {}

function sprites.loadFrameSprite(id, dat)
	local frameSprites = {}
	frameSprites.main = video.createSpriteState(id.."_main",  dat)
	if frameSprites.main < 0 then
		frameSprites.main = nil
	end
	frameSprites.left = video.createSpriteState(id.."_left", dat)
	frameSprites.right = video.createSpriteState(id.."_right", dat)
	frameSprites.top = video.createSpriteState(id.."_top", dat)
	frameSprites.bottom = video.createSpriteState(id.."_bottom", dat)
	frameSprites.topLeft = video.createSpriteState(id.."_topLeft", dat)
	frameSprites.topRight = video.createSpriteState(id.."_topRight", dat)
	frameSprites.bottomLeft = video.createSpriteState(id.."_bottomLeft", dat)
	frameSprites.bottomRight = video.createSpriteState(id.."_bottomRight", dat)
	local w,h = video.getSpriteStateSize(frameSprites.top)
	frameSprites.topHeight = h
	local w,h = video.getSpriteStateSize(frameSprites.left)
	frameSprites.leftWidth = w
	local w,h = video.getSpriteStateSize(frameSprites.topLeft)
	frameSprites.height = h
	frameSprites.width = w
	return frameSprites
end

function sprites.loadCustom(customDef)
	local sprites = {}
	if customDef and not def.customSprites then
		sprites = {}
		for index, spriteName in pairs(customDef) do
			image = video.createSpriteState(spriteName, dat)
			if type(index) == "string" then
				sprites[index] = image
			else
				sprites[spriteName] = image
			end
		end
	end
	return sprites
end

function sprites.loadSpriteVariations(name, vars, dat, padding)
	local sprites = {}
	for i=1, vars do
		sprites[i] = video.createSpriteState(name..string.format("%."..(padding or 1).."d", i), dat)
	end
	return sprites
end



function sprites.load()
	

	SPRITES.letter_c = video.createSpriteState("letters_c", "gui.dat")
	SPRITES.letter_e = video.createSpriteState("letters_e", "gui.dat")
	SPRITES.letter_l = video.createSpriteState("letters_l", "gui.dat")
	SPRITES.letter_s = video.createSpriteState("letters_s", "gui.dat")

	SPRITES.gradient = sprites.loadFrameSprite("gradient","gui.dat")
	SPRITES.bg = video.createSpriteState("bg_basetexture","gui.dat")
	SPRITES.corner = video.createSpriteState("bg_basetexture_corner","gui.dat")

	SPRITES.cellBody = video.createSpriteState("cell_body", "ingame.dat")
	SPRITES.cellBodySpiked = video.createSpriteState("cell_bodySpiked", "ingame.dat")
	SPRITES.cellBodyGlow = video.createSpriteState("cell_glowBG", "ingame.dat")

	SPRITES.cellSpike = video.createSpriteState("cell_spike", "ingame.dat")

	SPRITES.cellHighlight = video.createSpriteState("cell_highlight", "ingame.dat")
	SPRITES.cellNucleus = video.createSpriteState("cell_nucleus", "ingame.dat")

	SPRITES.spotlight = video.createSpriteState("spotlight", "ingame.dat")

	SPRITES.particles = sprites.loadSpriteVariations("particles_", 10, "ingame.dat")
	SPRITES.shockwave = video.createSpriteState("shockwave_local", "ingame.dat")

	SPRITES.creep = sprites.loadSpriteVariations("bgSprites_creep_", 9, "ingame.dat", 2)

	SPRITES.snakeBody = video.createSpriteState("bgSprites_snakecreep_body", "ingame.dat")
	
	SPRITES.snakeBody = video.createSpriteState("bgSprites_snakecreep_body", "ingame.dat")

	SPRITES.snakeBody = video.createSpriteState("bgSprites_snakecreep_body", "ingame.dat")
	SPRITES.snakeHead = video.createSpriteState("bgSprites_snakecreep_head", "ingame.dat")
	SPRITES.snakeMouth = video.createSpriteState("bgSprites_snakecreep_mouthp", "ingame.dat")
	SPRITES.snakeTail = video.createSpriteState("bgSprites_snakecreep_tail", "ingame.dat")

	SPRITES.wiggle = sprites.loadSpriteVariations("bgSprites_wiggle_", 7, "ingame.dat", 2)

	SPRITES.bigThings = sprites.loadSpriteVariations("bigthings_", 6, "ingame.dat", 2)

	SPRITES.wave = video.createSpriteState("wave_texture", "ingame.dat")
end
